( set-logic QF_AUFLIRA)
( set-info :source | SMT-COMP'06 organizers |)
( set-info :smt-lib-version 2.0)
( set-info :category "check")
( declare-sort char 0)
( declare-sort string 0)
( declare-datatypes ()
  (
    ( xml ( xml_Leaf ( destxml_Leaf string))
      ( xml_Node ( destxml_Node xmlList)))
    ( xmlList ( xmlList_nil)
      ( xmlList_cons ( destxmlList_cons xmlList_cons_recd)))
    ( xmlList_cons_recd
      ( xmlList_cons_recd ( xmlList_cons_recd_hd xml)
        ( xmlList_cons_recd_tl xmlList)))))
( declare-datatypes ()
  (
    ( byteList ( byteList_nil)
      ( byteList_cons ( destbyteList_cons byteList_cons_recd)))
    ( byteList_cons_recd
      ( byteList_cons_recd ( byteList_cons_recd_hd char)
        ( byteList_cons_recd_tl byteList)))))
( declare-datatypes ()
  (
    ( stringList ( stringList_nil)
      ( stringList_cons ( deststringList_cons stringList_cons_recd)))
    ( stringList_cons_recd
      ( stringList_cons_recd ( stringList_cons_recd_hd string)
        ( stringList_cons_recd_tl stringList)))))
( declare-datatypes ()
  ( ( prod1 ( prod1_br ( prod1_fst string) ( prod1_snd string)))))
( declare-datatypes ()
  (
    ( audit ( audit_Exec) ( audit_Virus) ( audit_Dirty_Word)
      ( audit_Exe_Suffix) ( audit_Unknown_Object_Type))))
( declare-datatypes ()
  (
    ( email
      ( email ( email_body string) ( email_attachments attachList)))
    ( attachList ( attachList_nil)
      ( attachList_cons ( destattachList_cons attachList_cons_recd)))
    ( attachType ( attachType_Email ( destattachType_Email email))
      ( attachType_Text ( destattachType_Text string))
      ( attachType_Xml ( destattachType_Xml xml))
      ( attachType_Binary ( destattachType_Binary byteList))
      ( attachType_Other))
    ( attach
      ( attach ( attach_name string) ( attach_object attachType)))
    ( attachList_cons_recd
      ( attachList_cons_recd ( attachList_cons_recd_hd attach)
        ( attachList_cons_recd_tl attachList)))))
( declare-datatypes ()
  (
    ( xmlResult ( xmlResult_Audit ( destxmlResult_Audit audit))
      ( xmlResult_Xml ( destxmlResult_Xml xml)))))
( declare-datatypes ()
  ( ( prod2 ( prod2_br ( prod2_fst1 string) ( prod2_snd1 stringList)))))
( declare-datatypes ()
  (
    ( stringResult
      ( stringResult_Audit ( deststringResult_Audit audit))
      ( stringResult_String ( deststringResult_String string)))))
( declare-datatypes ()
  (
    ( emailResult ( emailResult_Audit ( destemailResult_Audit audit))
      ( emailResult_Email ( destemailResult_Email email)))))
( declare-datatypes ()
  (
    ( attachListResult
      ( attachListResult_Audit ( destattachListResult_Audit audit))
      ( attachListResult_attachList
        ( destattachListResult_attachList attachList)))))
( declare-datatypes ()
  (
    ( attachResult
      ( attachResult_Audit ( destattachResult_Audit audit))
      ( attachResult_Attach ( destattachResult_Attach attach)))))
( declare-fun DIRTY_WORD_CHECKFn ( string) stringResult)
( declare-fun EXEC_CHECKFn ( byteList) Bool)
( declare-fun Email_GuardFn_ext ( email) emailResult)
( declare-fun M () email)
( declare-fun NOT_SUFFIX_CHECKFn ( prod2) Bool)
( declare-fun VIRUS_CHECKFn ( email) Bool)
( declare-fun XML_CHECKFn ( xml) xmlResult)
( declare-fun a () attach)
( declare-fun al () attachList)
( declare-fun alr () attachListResult)
( declare-fun ar () attachResult)
( declare-fun attachList_GuardFn_ext ( attachList) attachListResult)
( declare-fun attach_GuardFn_ext ( attach) attachResult)
( declare-fun er () emailResult)
( declare-fun s () string)
( declare-fun sp () prod1)
( declare-fun string_lit1 () string)
( declare-fun string_lit2 () string)
( declare-fun string_lit3 () string)
( declare-fun string_lit4 () string)
( declare-fun string_lit5 () string)
( declare-fun string_lit6 () string)
( declare-fun v3 () attach)
( declare-fun v4 () attachList)
( declare-fun v5 () email)
( define-fun String_EqFn ( ( sp prod1)) Bool
  ( = ( prod1_fst sp) ( prod1_snd sp)))
( define-fun textStableFn_ext ( ( s string)) Bool
  ( ite ( is-stringResult_Audit ( DIRTY_WORD_CHECKFn s)) false
    ( String_EqFn
      ( prod1_br s ( deststringResult_String ( DIRTY_WORD_CHECKFn s))))))
( define-fun DIRTY_WORD_CHECK_IdempotentFn_ext ( ( s string)) Bool
  ( ite ( is-stringResult_Audit ( DIRTY_WORD_CHECKFn s)) true
    ( ite
      ( is-stringResult_Audit
        ( DIRTY_WORD_CHECKFn
          ( deststringResult_String ( DIRTY_WORD_CHECKFn s))))
      false
      ( String_EqFn
        ( prod1_br ( deststringResult_String ( DIRTY_WORD_CHECKFn s))
          ( deststringResult_String
            ( DIRTY_WORD_CHECKFn
              ( deststringResult_String ( DIRTY_WORD_CHECKFn s)))))))))
( declare-fun attachResult_StableFn_ext ( attachResult) Bool)
( declare-fun attachListResult_StableFn_ext ( attachListResult) Bool)
( declare-fun attachStableFn_ext ( attach) Bool)
( declare-fun attachListStableFn_ext ( attachList) Bool)
( declare-fun emailStableFn_ext ( email) Bool)
( declare-fun emailResult_StableFn_ext ( emailResult) Bool)
( assert
  ( and ( not ( is-attachType_Email ( attach_object v3)))
    ( and ( is-attachType_Text ( attach_object v3))
      ( and
        ( not
          ( is-stringResult_Audit
            ( DIRTY_WORD_CHECKFn
              ( destattachType_Text ( attach_object v3)))))
        ( and
          ( NOT_SUFFIX_CHECKFn
            ( prod2_br ( attach_name v3)
              ( stringList_cons
                ( stringList_cons_recd string_lit3
                  ( stringList_cons
                    ( stringList_cons_recd string_lit2
                      ( stringList_cons
                        ( stringList_cons_recd string_lit4
                          ( stringList_cons
                            ( stringList_cons_recd string_lit1
                              ( stringList_cons
                                ( stringList_cons_recd string_lit6
                                  ( stringList_cons
                                    ( stringList_cons_recd string_lit5
                                      stringList_nil))))))))))))))
          ( and ( not ( = string_lit1 string_lit2))
            ( and ( not ( = string_lit1 string_lit3))
              ( and ( not ( = string_lit1 string_lit4))
                ( and ( not ( = string_lit1 string_lit5))
                  ( and ( not ( = string_lit1 string_lit6))
                    ( and ( not ( = string_lit2 string_lit3))
                      ( and ( not ( = string_lit2 string_lit4))
                        ( and ( not ( = string_lit2 string_lit5))
                          ( and ( not ( = string_lit2 string_lit6))
                            ( and ( not ( = string_lit3 string_lit4))
                              ( and ( not ( = string_lit3 string_lit5))
                                ( and
                                  ( not ( = string_lit3 string_lit6))
                                  ( and
                                    ( not ( = string_lit4 string_lit5))
                                    ( and
                                      ( not
                                        ( = string_lit4 string_lit6))
                                      ( and
                                        ( not
                                          ( = string_lit5 string_lit6))
                                        ( and
                                          (
                                            DIRTY_WORD_CHECK_IdempotentFn_ext
                                            ( deststringResult_String
                                              ( DIRTY_WORD_CHECKFn
                                                ( destattachType_Text
                                                  ( attach_object v3)))))
                                          ( and
                                            (
                                              DIRTY_WORD_CHECK_IdempotentFn_ext
                                              ( destattachType_Text
                                                ( attach_object v3)))
                                            ( and
                                              (
                                                DIRTY_WORD_CHECK_IdempotentFn_ext
                                                string_lit5)
                                              ( and
                                                (
                                                  DIRTY_WORD_CHECK_IdempotentFn_ext
                                                  string_lit6)
                                                ( and
                                                  (
                                                    DIRTY_WORD_CHECK_IdempotentFn_ext
                                                    string_lit1)
                                                  ( and
                                                    (
                                                      DIRTY_WORD_CHECK_IdempotentFn_ext
                                                      string_lit4)
                                                    ( and
                                                      (
                                                        DIRTY_WORD_CHECK_IdempotentFn_ext
                                                        string_lit2)
                                                      ( and
                                                        (
                                                          DIRTY_WORD_CHECK_IdempotentFn_ext
                                                          string_lit3)
                                                        ( and
                                                          (
                                                            DIRTY_WORD_CHECK_IdempotentFn_ext
                                                            (
                                                              attach_name
                                                              v3))
                                                          ( not
                                                            (
                                                              attachResult_StableFn_ext
                                                              (
                                                                attachResult_Attach
                                                                (
                                                                  attach
                                                                  (
                                                                    attach_name
                                                                    v3)
                                                                  (
                                                                    attachType_Text
                                                                    (
                                                                      deststringResult_String
                                                                      (
                                                                        DIRTY_WORD_CHECKFn
                                                                        (
                                                                          destattachType_Text
                                                                          (
                                                                            attach_object
                                                                            v3))))))))))))))))))))))))))))))))))))))
( assert
  ( =
    ( attachResult_StableFn_ext
      ( attachResult_Attach
        ( attach ( attach_name v3)
          ( attachType_Text
            ( deststringResult_String
              ( DIRTY_WORD_CHECKFn
                ( destattachType_Text ( attach_object v3))))))))
    ( ite
      ( is-attachResult_Audit
        ( attachResult_Attach
          ( attach ( attach_name v3)
            ( attachType_Text
              ( deststringResult_String
                ( DIRTY_WORD_CHECKFn
                  ( destattachType_Text ( attach_object v3))))))))
      true
      ( attachStableFn_ext
        ( destattachResult_Attach
          ( attachResult_Attach
            ( attach ( attach_name v3)
              ( attachType_Text
                ( deststringResult_String
                  ( DIRTY_WORD_CHECKFn
                    ( destattachType_Text ( attach_object v3))))))))))))
(check-sat)
(exit)
